/* zf20d.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer iter;
} zf20rr_;

#define zf20rr_1 zf20rr_

/* Table of constant values */

static integer c__20 = 20;

/* Subroutine */ int zf20d_c(D_fp f, doublereal *a, doublereal *b,
        doublereal *eps, doublereal *root, integer *itmax, integer *ierr)
{
    /* Initialized data */

    static doublereal zero = 0.;

    /* System generated locals */
    integer i__1;

    /* Local variables */
    static doublereal swap;
    static integer j;
    extern /* Subroutine */ int utzf11_c(integer *, integer *);
    static doublereal fh, fl, fr, dx, xh, xl, del;

    *ierr = 0;
    fl = (*f)(a);
    fh = (*f)(b);
    if (fl * fh <= zero) {
        goto L10;
    }
    *ierr = 66;
    goto L70;
L10:
    if (fl >= zero) {
        goto L20;
    }
    xl = *a;
    xh = *b;
    goto L30;
L20:
    xl = *b;
    xh = *a;
    swap = fl;
    fl = fh;
    fh = swap;
L30:
    dx = xh - xl;
    i__1 = *itmax;
    for (j = 1; j <= i__1; ++j) {
        zf20rr_1.iter = j;
        *root = xl + dx * fl / (fl - fh);
        fr = (*f)(root);
        if (fr >= zero) {
            goto L40;
        }
        del = xl - *root;
        xl = *root;
        fl = fr;
        goto L50;
L40:
        del = xh - *root;
        xh = *root;
        fh = fr;
L50:
        dx = xh - xl;
        if (abs(del) < abs(*eps) || fr == zero) {
            goto L80;
        }
/* L60: */
    }
    *ierr = 65;
L70:
    utzf11_c(ierr, &c__20);
L80:
    return 0;
} /* zf20d_c */
